<template>
  <div
    data-component-group="filter-forms"
    data-component="threads"
  >
    <FiltersForm
      :has-filters="hasFilters"
      @filter="onFilter"
      @clear="onClearFilters"
    >
      <Can
        I="see-thread-search"
        a="filter"
      >
        <v-text-field
          v-model="search"
          type="search"
          label="Search"
          prepend-inner-icon="search"
        />
      </Can>

      <Can
        I="assign-labels"
        a="thread"
      >
        <v-autocomplete
          v-model="selectedLabels"
          :items="labels"
          :filter="customFilter"
          :multiple="true"
          :loading="isLoadingLabels"
          label="Labels"
          item-text="name"
          item-value="id"
          :return-object="true"
          required
          prepend-inner-icon="label"
          :menu-props="{nudgeBottom:'10'}"
          :search-input.sync="labelSearch"
        />
      </Can>

      <Can
        I="see-thread-business"
        a="filter"
      >
        <v-autocomplete
          v-model="business"
          :items="businesses"
          :filter="customFilter"
          :loading="isLoadingBusinesses"
          prepend-inner-icon="home"
          :return-object="true"
          item-text="name"
          label="Business"
          :menu-props="{nudgeBottom:'10'}"
          :search-input.sync="businessSearch"
        />
      </Can>

      <Can
        I="see-thread-account-manager-list"
        a="filter"
      >
        <Can
          I="view"
          a="shop"
        >
          <v-autocomplete
            v-model="shop"
            :items="shops"
            :filter="customFilter"
            :loading="isLoadingShops"
            prepend-inner-icon="store"
            :return-object="true"
            item-text="name"
            label="Merchant"
            :menu-props="{nudgeBottom:'10'}"
            :search-input.sync="shopSearch"
          />
        </Can>
      </Can>

      <Can
        I="see-thread-category"
        a="filter"
      >
        <v-autocomplete
          v-model="category"
          :items="categories"
          :filter="customFilter"
          prepend-inner-icon="label"
          :return-object="true"
          item-text="name"
          label="Category"
          :menu-props="{nudgeBottom:'10'}"
        />
      </Can>

      <base-date-picker
        :date="dates"
        placeholder="Dates"
        :config="dateConfig"
        :on-change="onChangeDate"
      />

      <template
        v-if="$ability.can('see-thread-business', 'filter')
          || $ability.can('view-only-archived', 'thread')"
      >
        <v-autocomplete
          v-if="!isSimple"
          v-model="status"
          :items="filterStatuses"
          :filter="customFilter"
          prepend-inner-icon="network_check"
          :return-object="true"
          item-text="name"
          label="Status"
          :menu-props="{nudgeBottom:'10'}"
        />
      </template>

      <Can
        I="see-my-account-filter"
        a="filter"
      >
        <v-autocomplete
          v-if="!isSimple"
          v-model="selectedAccountTypes"
          :multiple="true"
          :items="accountTypes"
          :filter="customFilter"
          prepend-inner-icon="person"
          :return-object="true"
          item-text="name"
          label="Account type"
          :menu-props="{nudgeBottom:'10'}"
        />
      </Can>
    </FiltersForm>
  </div>
</template>

<script>
  import uid from 'uid';
  import colors from 'vuetify/es5/util/colors';
  import stringEscape from 'js-string-escape';
  import FiltersForm from './Filters';
  import { isStr, isNum, debounce } from '../../../utils';

  const debouncer = debounce({
    id: uid(),
    timeout: 500
  });

  // TODO: Translate component

  export default {
    components: {
      FiltersForm
    },
    props: {
      isArchived: {
        type: Boolean,
        default: false
      },
      isSimple: {
        type: Boolean,
        default: false
      }
    },
    data() {
      return {
        search: '',
        labelSearch: '',
        selectedLabels: [],
        business: {},
        businessSearch: '',
        businesses: [],
        category: {},
        shop: {},
        shopSearch: '',
        shops: [],
        dates: '',
        dateConfig: {
          mode: 'range'
        },
        status: {},
        selectedAccountTypes: [],
        isLoadingBusinesses: false,
        isLoadingShops: false,
        isLoadingLabels: false,
        colors
      };
    },
    computed: {
      labels() {
        return this.$store.getters['labels/items'];
      },
      statuses() {
        return this.$store.getters['threads/statuses'];
      },
      filterStatuses() {
        return this.$store.getters['threads/filterStatuses'];
      },
      country() {
        return this.$store.getters['config/country'];
      },
      categories() {
        return this.$store.getters['threads/categories'];
      },
      accountTypes() {
        return this.$store.getters['threads/accountTypes'];
      },
      hasFilters() {
        const { search, selectedLabels, business, category, shop, dates, status, selectedAccountTypes } = this;

        return search !== ''
          || selectedLabels.length > 0
          || isNum(business.id)
          || isStr(category.code)
          || isNum(shop.id)
          || dates !== ''
          || isNum(status.id)
          || selectedAccountTypes.length > 0;
      }
    },
    watch: {
      businessSearch(nextSearch) {
        if (isStr(nextSearch)) {
          debouncer(() => this.getBusinesses(nextSearch));
        }
      },
      shopSearch(nextSearch) {
        if (isStr(nextSearch)) {
          debouncer(() => this.getShops(nextSearch));
        }
      },
      labelSearch(nextSearch) {
        if (isStr(nextSearch)) {
          this.getLabels(nextSearch);
        }
      }
    },
    created() {
      const { labels, country } = this;
      const categoryQuery = {
        target_country: country.code
      };

      const accountTypeQuery = {
        archived: this.isArchived ? 1 : 0
      };

      if (labels.length === 0) {
        this.getLabels();
      }

      this.$store.dispatch('threads/getStatuses');
      this.$store.dispatch('threads/getCategories', categoryQuery);
      this.$store.dispatch('threads/getAccountTypes', accountTypeQuery);
      this.$store.dispatch('threads/getFilterStatuses', accountTypeQuery);
    },
    methods: {
      getBusinesses(search = '') {
        const query = {
          per_page: -1,
          search,
          target_country: this.country.code
        };

        this.isLoadingBusinesses = true;
        return this.$store.dispatch('businesses/getItems', query)
          .then(({ items }) => {
            this.businesses = items;
            this.isLoadingBusinesses = false;

            return items;
          })
          .catch((err) => {
            this.isLoadingBusinesses = false;
            return err;
          });
      },
      getShops(search = '') {
        const query = {
          per_page: -1,
          search
        };

        this.isLoadingShops = true;
        return this.$store.dispatch('shops/getItems', query)
          .then(({ items }) => {
            this.shops = items;
            this.isLoadingShops = false;

            return items;
          })
          .catch((err) => {
            this.isLoadingShops = false;
            return err;
          });
      },
      getLabels(search = '') {
        const query = {
          search
        };

        this.isLoadingLabels = true;
        return this.$store.dispatch('labels/getItems', query)
          .then((res) => {
            this.isLoadingLabels = false;
            return res;
          })
          .catch((err) => {
            this.isLoadingLabels = false;
            return err;
          });
      },
      onFilter() {
        const { search, selectedLabels, business, shop, category, dates, status, selectedAccountTypes } = this;
        const formattedSearch = stringEscape(search);

        this.$emit('filter', {
          search: formattedSearch,
          labels: selectedLabels,
          business,
          shop,
          category,
          dates,
          status,
          accountTypes: selectedAccountTypes
        });
      },
      onClearFilters() {
        this.search = '';
        this.selectedLabels = [];
        this.business = {};
        this.shop = {};
        this.category = {};
        this.shopSearch = '';
        this.dates = '';
        this.status = {};
        this.selectedAccountTypes = [];

        this.$emit('clearFilters');
      },
      customFilter(item, queryText) {
        const textOne = item.name.toLowerCase();
        const searchText = queryText.toLowerCase();

        return textOne.indexOf(searchText) > -1;
      },
      onFilterShops(search) {
        const query = {
          per_page: -1,
          search
        };

        this.isLoadingShops = true;
        return this.$store.dispatch('shops/getItems', query)
          .then((res) => {
            this.isLoadingShops = false;
            return res;
          })
          .catch((err) => {
            this.isLoadingShops = false;
            return err;
          });
      },
      onChangeDate(dates) {
        this.dates = dates;
      }
    }
  };
</script>

<style lang="stylus" scoped>
  @import "../../../assets/stylus/theme.styl";

  [data-component-group="filter-forms"] {
    &[data-component="threads"] {
      h1 {
        display: flex;
        align-items: center;
        margin: 0 0 32px 0;
        min-height: 48px;
      }

      .v-select__selection {
        color: $colors.shades.white;
        background-color: $colors.primary;
        border-radius: 4px;
        padding: 5px;
      }
    }
  }
</style>
